/**
 * @since 1.17.0
 */
export const showString = {
    show: a => JSON.stringify(a)
};
/**
 * @since 1.17.0
 */
export const showNumber = {
    show: a => JSON.stringify(a)
};
/**
 * @since 1.17.0
 */
export const showBoolean = {
    show: a => JSON.stringify(a)
};
/**
 * @since 1.17.0
 */
export const getStructShow = (shows) => {
    return {
        show: s => `{ ${Object.keys(shows)
            .map(k => `${k}: ${shows[k].show(s[k])}`)
            .join(', ')} }`
    };
};
/**
 * @since 1.17.0
 */
export const getTupleShow = (...shows) => {
    return {
        show: t => `[${t.map((a, i) => shows[i].show(a)).join(', ')}]`
    };
};
